
import {toPlayable, parseNote} from './keyData';

export const parseSong = (s: string, tempo: number) => {
	return s.split(' ').reduce((state, n, notes) => {
		let note
		try {
			note = parseNote(n)
		} catch {
			return state
		}
		const playable = toPlayable(note, tempo)
		return {
			...state,
			notes: [
				...state.notes,
				{
					key: playable.key,
					start: state.duration,
					end: state.duration + playable.duration,
					startIndex: state.index,
					endIndex: state.index + n.length
				}
			],
			duration: state.duration + playable.duration,
			index: state.index + n.length + 1
		}
	}, {
		notes: [],
		duration: 0,
		index: 0,
	})
}
