export default class WaveOscillator {
	private oscillator: OscillatorNode

	private static getKeyFrequency(keyNumber: number) {
		return 440 * Math.pow(Math.pow(2, 1 / 12), keyNumber - 69)
	}

	start(keyNumber: number) {
		const audioContext = new AudioContext()
		const gainNode = audioContext.createGain()
		gainNode.gain.value = 0.05

		this.oscillator = audioContext.createOscillator()
		this.oscillator.type = 'square'
		this.oscillator.connect(gainNode)
		gainNode.connect(audioContext.destination)
		this.oscillator.frequency.value = WaveOscillator.getKeyFrequency(keyNumber)
		this.oscillator.start()
	}

	stop() {
		try {
			this.oscillator.stop()
		} catch {}
	}
}
